import poser

scene = poser.Scene()

class UnderWaterAutomator(object):
	lastCameraPosition = None
	lastUnit = None
	lastSurface = None
	lastHalfDistance = None
	lastScatter = None

	def Actor(self, name):
		scene = self.scene
		try:
			return scene.Actor(name)
		except:
			return scene.Actor(name + "_1")

	def parameterAutomationCallback(self, scene, e):
		self.scene = scene
		cam = scene.CurrentCamera()
		pos = cam.WorldDisplacement()
		shaderTree = scene.AtmosphereShaderTree()
		posNode, halfDistanceNode = self.fromShaderTreeGet(shaderTree, 
			'PM:Camera Position', 'PM:Half Distance')
		k = 103.200005
		halfDistance = halfDistanceNode.Input(1).Value()
		if pos != self.lastCameraPosition:
			print 'Camera position updated'
			self.lastCameraPosition = pos
			for i in xrange(3):
				posNode.Input(i).SetFloat(pos[i] * k)
			shaderTree.UpdatePreview()
				

	def fromShaderTreeGet(self, shaderTree, *names):
		nodes = shaderTree.Nodes()
		lookup = {}
		for node in nodes:
			lookup[node.Name()] = node
		rv = [lookup.get(name) for name in names]
		if len(names) == 1:
			return rv[0]
		return rv

	def activate(self):
		poser.Scene().SetEventCallback(self.parameterAutomationCallback)
		print 'Parameter Automation Activated'

	def deactivate(self):
		poser.Scene().ClearEventCallback()
		print 'Parameter Automation Deactivated'


if 'bb_memo' not in sys.modules:
	import imp
	sys.modules['bb_memo'] = imp.new_module('bb_memo')


UnderWaterAutomator().activate()
